/**************************************************************
Es soll alle halbe Sekunde im Wechsel 0 bzw. 1 gesendet werden.
Am korrespondierenden Slave soll zur Indikation jeweils die 
LEDs an bzw. aus gehen
Verdrahtung:	MISO(Master) --> MISO(Slave)
				MOSI(Master) --> MOSI(Slave)
				SCK(Master)  --> SCK(Slave)
				PB0(Master)	 --> SS(Slave)
**************************************************************/

#include <avr/io.h>
#include <avr/interrupt.h>
//#include <avr/signal.h>
#include "display.c"
#include "uartapi_avr.c"

#include "timer.c"

unsigned char status = 0;
volatile unsigned char count;
volatile unsigned char data;
volatile char wait = 0, arsch;
void timer1 (void);
void master_init (void);
void master_transmit (unsigned char data);
void ISR0(void);


void uart_tx_ready(byte port);
void uart_rx_ready(byte port, byte data);
void uart_err(byte port, byte error_code);


void uart_tx_ready(byte port){}
void uart_rx_ready(byte port, byte data){}
void uart_err(byte port, byte error_code){}

SIGNAL (SIG_SPI) {
	//PORTB |= _BV(PB0);
	//PORTA = 0xff;
	//return;
	data = SPDR;
	//PORTA = data;
	writeChar(data,1);
	writeCharArr('a',3);
	//uart_tx(0, 0x63, FALSE);
	uart_tx(0, data, FALSE);
	if (data == '1'){
		//PORTA = 0xff;			//LEDs an
		//SPDR = data;
	}
	if (data == '0'){
		//PORTA = 0x00;			//LEDs aus
		//SPDR = data;
	}
}

SIGNAL (SIG_OVERFLOW1) {						//Senderoutine
// 	if (count == 1) {
// 		master_transmit ('1');
// 		count--;
// 		return;
// 	}
// 	if (count == 0) {
// 		master_transmit ('0');
// 		count++;
// 	}
// 	if(arsch == 0){
// 	PORTA = 0xf0;
// 	arsch = 1;
// 	}else{
// 	PORTA = 0x0f;
// 	arsch = 0;
// 	}
	
//	wait = 0;
}

void ISR0(void){
	wait = 0;
}

ISR(SIG_INTERRUPT0){
	//GICR &= ~_BV(INT0) & ~_BV(INT1);
	//sei();
	if(wait == 0){
		register_timer(1000, FALSE, 1, ISR0);
		wait = 1;
		//PORTA = 0xf0;
		master_transmit (0x63);
		arsch = 0;
	}
}

ISR(SIG_INTERRUPT1){
	//GICR &= ~_BV(INT0) & ~_BV(INT1);
	if(wait == 0){
		register_timer(1000, FALSE, 1, ISR0);
		wait = 1;
		//PORTA = 0xf0;
		master_transmit (0x64);
	arsch = 1;
	}
	
	//register_timer(2000, FALSE, 1, ISR0);
	//uart_read_bytes(0, (byte *) datum, 1, 1, (byte*) length);
	//uart_rx(0, (byte *)datum);
	//}
}
void timer1 (void) {
	TIMSK |= _BV(TOIE1);           				//Timer Overflow Interrupt enable
	TCNT1 = 0;                					//R�cksetzen des Timers
	TCCR1B = _BV(CS10) | _BV(CS11);			//8MHz/65536/64 = 1,91Hz --> 0,5s
}

void master_init (void) {
	DDRB = _BV(PB0) | _BV(PB7) | _BV(PB5) | _BV(PB4);		// setze SCK,MOSI,PB0 (SS) als Ausgang
	DDRB &= ~_BV(PB6);							// setze MISO als Eingang
	PORTB = _BV(PB7) | _BV(PB0);// | _BV(PB4);				// SCK und PB0 high (ist mit SS am Slave verbunden)
	SPCR = _BV(SPE) | _BV(SPIE) | _BV(MSTR) | _BV(SPR0);	//Aktivierung des SPI, Master, Taktrate fck/16
	status = SPSR;								//Status l�schen
}

void master_transmit (unsigned char data) {
	PORTB &= ~_BV(PB0);						//SS am Slave Low --> Beginn der �bertragung
	SPDR = data;								//Schreiben der Daten
	while (!(SPSR & (1<<SPIF)));
	//PORTA = SPDR;
	//PORTB |= _BV(PB0);							//SS High --> Ende der �bertragung
}

int main (void) {
	//DDRA = 0xff;
	//DDRD = 0x00;
	PORTD = 0x0c;

	
	//PORTA = 0xff;
	MCUCR |= _BV(ISC01) | _BV(ISC11);
	GICR |= _BV(INT0) | _BV(INT1);
	master_init ();
	//timer1 ();
	init_Digit();
	initTimer2();
	uart_init(FALSE, 0, UART_DATA_8, UART_STOP_1, UART_BPS_19200,\
			UART_PARITY_EVEN, uart_rx_ready,\
					uart_tx_ready, uart_err);
	sei ();

	for (;;);
	return 0;
}
