/**************************************************************
Es soll alle halbe Sekunde im Wechsel 0 bzw. 1 gesendet werden.
Am korrespondierenden Slave soll zur Indikation jeweils die 
LEDs an bzw. aus gehen
Verdrahtung:	MISO(Master) --> MISO(Slave)
				MOSI(Master) --> MOSI(Slave)
				SCK(Master)  --> SCK(Slave)
				PB0(Master)	 --> SS(Slave)
**************************************************************/

#include <avr/io.h>
#include <avr/interrupt.h>
//#include <avr/signal.h>
#include "display.c"
#include "uartapi_avr.c"

#include "timer.c"

volatile unsigned char data;
unsigned char status;

void uart_tx_ready(byte port);
void uart_rx_ready(byte port, byte data);
void uart_err(byte port, byte error_code);

SIGNAL (SIG_SPI) {
	data = SPDR;
	writeChar(data, 4);
	uart_tx(0, 0x68,FALSE);
	SPDR = 0x63;
	if (data == 0x63){
		
		//PORTA = 0x00;			//LEDs an
		//SPDR = '1';
	}
	if (data == 0x64){
		//PORTA = 0xff;			//LEDs aus
		//SPDR = '0';
	}
}
void uart_tx_ready(byte port){}
void uart_rx_ready(byte port, byte data){}
void uart_err(byte port, byte error_code){}
void slave_init (void) {
	DDRB |= _BV(PB6);							//MISO als Ausgang, der Rest als Eingang
	SPCR = _BV(SPE) | _BV(SPIE);				//Aktivierung des SPI + Interrupt
	status = SPSR;								//Status l�schen
}

int main (void) {
	//DDRA = 0xff;
	//PORTA = 0xff;
	slave_init ();
	init_Digit();
	initTimer2();
	if(uart_init(FALSE, 0, UART_DATA_8, UART_STOP_1, UART_BPS_19200,\
			UART_PARITY_EVEN, uart_rx_ready,\
					uart_tx_ready, uart_err) != RET_SUCCESS){
				//writeInt(2,2);
					}
	sei ();
	writeChar('a',1);
	writeChar('a',5);
	writeChar('a',4);
	writeChar('a',3);
	writeChar('a',2);
	
	for (;;);
	return 0;
}
